	device zxspectrum128
        ORG #6000
begin
; debug grid
;	ld hl,$5800,de,$5803,bc,765:set 6,(hl):ldir
;init music
	ld hl,song
	call INIT
;setup int
	di
	ld hl,$BE00
	ld de,$BE01
	ld bc,256
	ld (hl),$BF
	ldir
	
	ld a,$C3
	ld ($BFBF),a
	ld hl,intvec
	ld ($BFC0),hl
	ld a,$BE
	ld i,a
	im 2
	ei

;convert font
	ld de,$B000
	ld hl,zxf
cf1:
	push de
	ld b,8
cf2:
	ld a,(hl)
	inc hl
	ld (de),a
	inc d
	djnz cf2
	pop de
	inc e
	jr nz,cf1

runi:
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr

;out text
	ld ix,t1
	ld de,#4000
ol1:
	push de
	call pr8x4
	pop de
	ld a,e
	add a,32
	ld e,a
	sbc a,a
	and 8
	add a,d
	ld d,a
	ld a,(ix+0)
	or a
	jp nz,ol1

	ld hl,$5800,de,$5801,bc,767,(hl),$46:ldir

	call ramk
;key loop
kl:
;keyup
	ld a,$EF
	in a,($FE)
	and 8
	jr nz,keyd
	ld a,(cy)
	or a
	jr nz, nodlp
	ld a,12
nodlp:
	call ramk
	dec a
	ld (cy),a
	call ramk
	jp kwa

keyd:
	ld a,$EF
	in a,($FE)
	and 16
	jr nz,keye
	ld a,(cy)
	cp 11
	jr nz, noulp
	ld a,-1
noulp:
	call ramk
	inc a
	ld (cy),a
	call ramk
	jp kwa
keye: ;?0 or enter
	ld a,$EF
	in a,($FE)
	rra
	jp nc,extract

	ld a,$BF
	in a,($FE)
	rra
	jp nc,extract
	jp kl
kwa:
	ld b,5
kw ei
	halt
	djnz kw
	jp kl

pict:
 dw pic1,pic2,pic3,pic4,pic5,pic6
 dw pic7,pic8,pic9,pic10,pic11,pic12
extract:
;	jr $
	ld hl,(cy)
	ld h,0
	ld de,pict
	add hl,hl
	add hl,de
	ld e,(hl)
	inc hl
	ld d,(hl)
	ex de,hl
	ld de,$B800
	call dzx7_standard
	
	ld ix,$B800
	ld hl,$5800
	ld de,$4000
sp1:
	ld a,(ix+0)
	inc ix
	ld (hl),a
	inc hl
	ld a,(ix+0)
	add a,32
	ld c,a
	inc ix
	ld b,$B0
	push de
 dup 8
  ld a,(bc)
  ld (de),a
  inc b
  inc d
edup
	pop de
	inc e
	jp nz,sp1
	ld a,d
	add a,8
	ld d,a
	cp $58
	jp nz,sp1
	call wkey
 	jp runi
pr8x4:
	ld a,(ix+0):inc ix
	or a:ret z
;1
	ld l,a
	ld h,0
	ld bc,f8x4
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	ld b,d
 dup 8
 ld a,(hl)
 ld (de),a
 inc hl
 inc d
edup
	ld d,b

	ld a,(ix+0):inc ix
	or a:ret z
;2
	ld l,a
	ld h,0
	ld bc,f8x4
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	ld b,d
 dup 8
	ld a,(de)
	ld c,a
 ld a,(hl)
 rrca
 rrca
 rrca
 rrca
 or c
 ld (de),a
 inc hl
 inc d
edup
	ld d,b
	inc e
	jp pr8x4
wkey:
	xor a
	in a,($FE)
	cpl
	and 31
	jr z,wkey
	ret
;
intvec:
	push ix;,iy
	push hl,de,bc,af
	exx:exa
	push hl,de,bc,af
	CALL PLAY
	pop af,bc,de,hl
	exx:exa
	pop af,bc,de,hl
	pop ix
	ei:ret

ramk:
	push af
	ld hl,(cy)
	ld h,0
	ld de,$5840
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,de
	ld b,32
ra1:
	ld a,(hl)
	xor 1*8+1
	ld (hl),a
	inc l
	djnz ra1
	pop af
	ret
cy:db 0 ; cursor Y
;
song:incbin "MR_conor-adv98boot.pt3"
plyr:include "PTxPlay.a80"
f8x4 incbin "8x4.fnt"
zxf incbin "ZX_SPECTRUM.fnt"
zx7:include "zx7.a80"
pic1:incbin "pg0\01.bin.zx7"
pic2:incbin "pg0\02.bin.zx7"
pic3:incbin "pg0\03.bin.zx7"
pic4:incbin "pg0\04.bin.zx7"
pic5:incbin "pg0\05.bin.zx7"
pic6:incbin "pg0\06.bin.zx7"
pic7:incbin "pg0\07.bin.zx7"
pic8:incbin "pg0\08.bin.zx7"
pic9:incbin "pg0\09.bin.zx7"
pic10:incbin "pg0\10.bin.zx7"
pic11:incbin "pg0\11.bin.zx7"
pic12:incbin "pg0\12.bin.zx7"
t1: db "                  , zxgfx compo #5, 30.07.2022",0
 db " ",0
    db "1.- ? - , ... by Art-top vts:32 pts:281 avg:8.78",0
    db "2.SpecSCII Underwater World by pixelrat vts:32 pts:265 avg:8.28",0
    db "3.Scuba Platformer Mock-up by Grongy vts:32 pts:263 avg:8.22",0
    db "4.Pineapple Under the Sea by Grongy vts:33 pts:270 avg:8.18",0
    db "5.Coral Reef by Grongy vts:32 pts:255 avg:7.97",0
    db "6. ᨭ ,   . by Art-top vts:32 pts:249 avg:7.78",0
    db "7.Exoquarium by pixelrat vts:32 pts:246 avg:7.69",0
    db "8.Dire Dire Dock by pixelrat vts:31 pts:229 avg:7.39",0
    db "9.z80 water physics by Grongy vts:33 pts:206 avg:6.24",0
    db "10.Krym by aGGreSSor vts:31 pts:188 avg:6.06",0
    db "11.㫠  by Grongy vts:32 pts:190 avg:5.94",0
    db "12.Scubas by g0blinish vts:30 pts:153 avg:5.10",0
 db 0 ; end of list
end
	display /d,end-begin
	savesna "!void.sna",begin
	savebin "wwss.bin",begin,end-begin
	display end
